//------------------------------------------------------------------
//
//------------------------------------------------------------------
#property indicator_separate_window
#property indicator_buffers 4
#property indicator_color1  LimeGreen
#property indicator_color2  Green
#property indicator_color3  Red
#property indicator_color4  Maroon
#property indicator_width1  2
#property indicator_width3  2
#property indicator_minimum 0
#property indicator_maximum 1

extern int    Mom_period   = 1;
extern double T3_period    = 28;
extern bool   T3_original  = false;
extern double T3_hot       = 0.618;
extern bool   ColorOnSlope = true;

double upd[];
double upu[];
double dnu[];
double dnd[];
double t3[];
double trend[];

//------------------------------------------------------------------
//
//------------------------------------------------------------------
int init()
{
    IndicatorDigits(Digits);
    IndicatorBuffers(6);
    SetIndexBuffer(0,upd); SetIndexStyle(0,DRAW_HISTOGRAM);
    SetIndexBuffer(1,upu); SetIndexStyle(1,DRAW_HISTOGRAM);
    SetIndexBuffer(2,dnu); SetIndexStyle(2,DRAW_HISTOGRAM);
    SetIndexBuffer(3,dnd); SetIndexStyle(3,DRAW_HISTOGRAM);
    SetIndexBuffer(4,t3);
    SetIndexBuffer(5,trend);
      IndicatorShortName("T3 Momentum Burst "+DoubleToStr(T3_period,2));
    return(0);
}

//------------------------------------------------------------------
//
//------------------------------------------------------------------
int start()
{
   int counted_bars = IndicatorCounted();
      if(counted_bars < 0) return(-1);
      if(counted_bars > 0) counted_bars--;
         int limit = MathMin(Bars-counted_bars,Bars-1);

   //
   //
   //
   //
   //
   
   for(int i=limit; i>=0; i--)
   {
      t3[i]  = iT3(iMomentum(NULL,0,Mom_period,PRICE_CLOSE,i)-iMomentum(NULL,0,Mom_period,PRICE_CLOSE,i+1),T3_period,T3_hot,T3_original,i);
      upu[i] = EMPTY_VALUE;
      upd[i] = EMPTY_VALUE;
      dnd[i] = EMPTY_VALUE;
      dnu[i] = EMPTY_VALUE;
      trend[i] = trend[i+1];
         if (ColorOnSlope)
         {
            if (t3[i]>t3[i+1]) trend[i] =  1;
            if (t3[i]<t3[i+1]) trend[i] = -1;
         }
         else
         {
            if (t3[i]>0) trend[i] =  1;
            if (t3[i]<0) trend[i] = -1;
         }
         if (trend[i]== 1 && t3[i]<0) upd[i] = 1;
         if (trend[i]== 1 && t3[i]>0) upu[i] = 1;
         if (trend[i]==-1 && t3[i]>0) dnu[i] = 1;
         if (trend[i]==-1 && t3[i]<0) dnd[i] = 1;
   }         
      
   return(0);
}

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

double workT3[][6];
double workT3Coeffs[][6];
#define _period 0
#define _c1     1
#define _c2     2
#define _c3     3
#define _c4     4
#define _alpha  5

//
//
//
//
//

double iT3(double price, double period, double hot, bool original, int i, int instanceNo=0)
{
   if (ArrayRange(workT3,0) != Bars)                ArrayResize(workT3,Bars);
   if (ArrayRange(workT3Coeffs,0) < (instanceNo+1)) ArrayResize(workT3Coeffs,instanceNo+1);

   if (workT3Coeffs[instanceNo][_period] != period)
   {
     workT3Coeffs[instanceNo][_period] = period;
        double a = hot;
            workT3Coeffs[instanceNo][_c1] = -a*a*a;
            workT3Coeffs[instanceNo][_c2] = 3*a*a+3*a*a*a;
            workT3Coeffs[instanceNo][_c3] = -6*a*a-3*a-3*a*a*a;
            workT3Coeffs[instanceNo][_c4] = 1+3*a+a*a*a+3*a*a;
            if (original)
                 workT3Coeffs[instanceNo][_alpha] = 2.0/(1.0 + period);
            else workT3Coeffs[instanceNo][_alpha] = 2.0/(2.0 + (period-1.0)/2.0);
   }
   
   //
   //
   //
   //
   //
   
   int buffer = instanceNo*6;
   int r = Bars-i-1;
   if (r == 0)
      {
         workT3[r][0+buffer] = price;
         workT3[r][1+buffer] = price;
         workT3[r][2+buffer] = price;
         workT3[r][3+buffer] = price;
         workT3[r][4+buffer] = price;
         workT3[r][5+buffer] = price;
      }
   else
      {
         workT3[r][0+buffer] = workT3[r-1][0+buffer]+workT3Coeffs[instanceNo][_alpha]*(price              -workT3[r-1][0+buffer]);
         workT3[r][1+buffer] = workT3[r-1][1+buffer]+workT3Coeffs[instanceNo][_alpha]*(workT3[r][0+buffer]-workT3[r-1][1+buffer]);
         workT3[r][2+buffer] = workT3[r-1][2+buffer]+workT3Coeffs[instanceNo][_alpha]*(workT3[r][1+buffer]-workT3[r-1][2+buffer]);
         workT3[r][3+buffer] = workT3[r-1][3+buffer]+workT3Coeffs[instanceNo][_alpha]*(workT3[r][2+buffer]-workT3[r-1][3+buffer]);
         workT3[r][4+buffer] = workT3[r-1][4+buffer]+workT3Coeffs[instanceNo][_alpha]*(workT3[r][3+buffer]-workT3[r-1][4+buffer]);
         workT3[r][5+buffer] = workT3[r-1][5+buffer]+workT3Coeffs[instanceNo][_alpha]*(workT3[r][4+buffer]-workT3[r-1][5+buffer]);
      }

   //
   //
   //
   //
   //
   
   return(workT3Coeffs[instanceNo][_c1]*workT3[r][5+buffer] + 
          workT3Coeffs[instanceNo][_c2]*workT3[r][4+buffer] + 
          workT3Coeffs[instanceNo][_c3]*workT3[r][3+buffer] + 
          workT3Coeffs[instanceNo][_c4]*workT3[r][2+buffer]);
}